<?php

declare(strict_types=1);

namespace Dedi\SyliusColissimoPlugin\DependencyInjection;

use Dedi\SyliusColissimoPlugin\Colissimo\ColissimoParameters;
use Symfony\Component\Config\FileLocator;
use Symfony\Component\DependencyInjection\ContainerBuilder;
use Symfony\Component\DependencyInjection\Extension\Extension;
use Symfony\Component\DependencyInjection\Loader\YamlFileLoader;

final class DediSyliusColissimoExtension extends Extension
{
    /**
     * {@inheritdoc}
     */
    public function load(array $config, ContainerBuilder $container): void
    {
        $config = $this->processConfiguration($this->getConfiguration([], $container), $config);
        $loader = new YamlFileLoader($container, new FileLocator(__DIR__ . '/../Resources/config'));

        $loader->load('services.yaml');

        $container->setParameter(ColissimoParameters::COLISSIMO_LOGIN, $config['login']);
        $container->setParameter(ColissimoParameters::COLISSIMO_PASSWORD, $config['password']);
        $container->setParameter(ColissimoParameters::COLISSIMO_DEFAULT_LOCALE, $config['default_locale']);
        $container->setParameter(ColissimoParameters::COLISSIMO_COUNTRY_LIST, $config['country_list']);
        $container->setParameter(ColissimoParameters::COLISSIMO_COUNTRY, $config['country']);
        $container->setParameter(ColissimoParameters::COLISSIMO_PREPARATION_TIME, $config['preparation_time']);
        $container->setParameter(ColissimoParameters::COLISSIMO_URL_SERVER, $config['url_colissimo']);
        $container->setParameter(ColissimoParameters::COLISSIMO_SHIPPING_METHOD_CODE, $config['shipping_method_code']);
    }
}
